/////////////////////////////////////////////////////////////////////
// Code/helloworld.cpp
// One of the EDGELIB tutorial samples for iPhone
//
// Copyright (c) 2008 Elements Interactive Mobile B.V.
// http://www.edgelib.com
//
// Show "hello world" on the screen and exit by tapping the screen
/////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////
// Include and link the library                                    //
/////////////////////////////////////////////////////////////////////

//Include EDGELIB
#include "edgemain.h"

/////////////////////////////////////////////////////////////////////
// Class definition                                                //
/////////////////////////////////////////////////////////////////////

//The main class
class ClassMain : public ClassEdge
{
public:
		ClassMain(void);
		~ClassMain(void);
	ERESULT OnDisplayConfig(EDISPLAYCONFIG *config);
		ERESULT OnNextFrame(ClassEDisplay *display, unsigned long timedelta);
		void OnStylusDown(POINT pnt);
	
protected:
		int m_iStylusDownX, m_iStylusDownY;
};


/////////////////////////////////////////////////////////////////////
// ClassMain: public                                               //
/////////////////////////////////////////////////////////////////////

//ClassMain: constructor
ClassMain::ClassMain(void)
{
}

//ClassMain: destructor
ClassMain::~ClassMain(void)
{
}

ERESULT
ClassMain::OnDisplayConfig(EDISPLAYCONFIG *config)
{
	config->orientation = DOR_LANDSCAPE;
	return E_OK;
}

//Callback: Called every frame
ERESULT ClassMain::OnNextFrame(ClassEDisplay *display, unsigned long timedelta)
{
#if 1
	display->buffer.FillRect(NULL, 0);
	char szAuxBuffer[24] = {0};
	sprintf(szAuxBuffer,"x:%d  y:%d",m_iStylusDownX,m_iStylusDownY);
	display->buffer.DrawFont(10,10,&(display->fontinternal),szAuxBuffer);
#endif
	return(E_OK);
}

//Callback: Called when the user points the stylus down or clicks the left mouse button
void
ClassMain::OnStylusDown(POINT pnt)
{
#if 0 // Switch to 1 in order to obtain coords. relative to the top left corner of the screen (assuming that
	// the phone is rotated and that the HOME button is located at the right).
	m_iStylusDownX = pnt.y;
	m_iStylusDownY = 320-pnt.x;
#else
	m_iStylusDownX = pnt.x;
	m_iStylusDownY = pnt.y;
#endif
} // End ClassMain::OnStylusDown().

//////////////////////////////////////////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////
// The program entry point                                         //
/////////////////////////////////////////////////////////////////////

ClassEdge *EdgeMain(EDGESTARTUP *data){ return(new ClassMain); }
